utf8 = require("utf8")
local theme= require("colours")
local highlights={}
local combo={}
local closures={}
local brackets={theme[2],theme[3]}
local blocks={theme[6],theme[7]}
combo["="]={["="]=theme[12],["~"]=theme[13],[">"]=theme[14],["<"]=theme[14]}
highlights["="]=theme[1]
brackets['{']='}'
brackets['[']=']'
brackets['(']=')'
closures["-"]={["-"]={theme[5],["\n"]=true,["["]="-"}}
closures["["]={["["]={theme[9],["]"]="]"}}
closures["'"]={theme[4],["'"]=true,["\n"]=true}
closures['"']={theme[4],['"']=true,["\n"]=true}

highlights["true"]=theme[12]
highlights["false"]=theme[12]
highlights["nil"]=theme[12]

blocks['repeat']='until'
blocks['if']='end'
blocks['function']='end'
blocks['do']='end'

highlights["else"]=theme[1]
highlights["elseif"]=theme[1]
highlights["while"]=theme[1]
highlights["then"]=theme[1]
highlights["for"]=theme[1]
highlights["break"]=theme[1]
highlights["until"]=theme[1]
highlights["return"]=theme[1]
highlights["local"]=theme[1]
highlights["and"]=theme[1]
highlights["in"]=theme[1]
highlights["or"]=theme[1]
highlights["not"]=theme[1]
highlights["goto"]=theme[1]
highlights["end"]=theme[1]
highlights["repeat"]=theme[1]

for k,v in pairs(_G) do 
 highlights[k]=theme[10]
 if type(v)=="table" then
  for kk,vv in pairs(v) do
   if type(vv)=="function" then
    highlights[k..'.'..kk]=theme[8]
   end
  end  
 end
end
highlights["love"]=theme[9]
for k,v in pairs(love) do 
 highlights["love."..k]=theme[9]
 if type(v)=="table" then
  for kk,vv in pairs(v) do
   highlights["love."..k.."."..kk]=theme[9]
   if type(vv)=="table" then
    for kkk,vvv in pairs(vv) do
     highlights["love."..k.."."..kk.."."..kkk]=theme[9]
    end
   end
  end  
 end
end

local function parser(lines,start,ennd)
 start=start or 0
 ennd= ennd or #lines
 local colourlines={}
 brackets._close={} 
 blocks._close={} 
 local colourdetect=false
 local open=0
 local lastw=""
 local lasts=""
 for l=start, ennd do
  local rest=""
  local colourline={}
  if open~=0 then colourline[1]=open[1] end
  for pos, word,noword in string.gmatch(lines[l] or "" ,"()([%a%d.]*)("..utf8.charpattern..")") do
   if open==0 then
    if word~="" then
     colourline[#colourline+1]=highlights[word] or theme[11]
     if blocks[word] then
      colourline[#colourline]=blocks[1]
      if not blocks._close[blocks[word]] then blocks._close[blocks[word]]={} end
      blocks._close[blocks[word]][#blocks._close[blocks[word]]+1]={#colourline,l}
     elseif blocks._close[word] then
      if #blocks._close[word]==0 then
       colourline[#colourline]=blocks[1]
      else
       if blocks._close[word][#blocks._close[word]][2]==l then
        colourline[blocks._close[word][#blocks._close[word]][1]]=blocks[2]
        blocks._close[word][#blocks._close[word]]=nil
       else
        colourlines[blocks._close[word][#blocks._close[word]][2]][blocks._close[word][#blocks._close[word]][1]]=blocks[2]
        blocks._close[word][#blocks._close[word]]=nil
       end
       colourline[#colourline]=blocks[2]
      end
     end
    colourline[#colourline+1]=word
    end
    if lasts=="{" and type(tonumber(word))=="number" then 
     colourdetect={tonumber(word)}
    elseif colourdetect and type(tonumber(word))=="number" then
     colourdetect[#colourdetect+1]=tonumber(word)
    else colourdetect=false
    end
    if closures[noword] and closures[noword][1] then
     colourline[#colourline+1]=closures[noword][1]
     rest=noword
     open=closures[noword]
    elseif closures[noword] and closures[noword][lasts] and word=="" then
     colourline[#colourline-1]=closures[noword][lasts][1]
     rest=noword
     open=closures[noword][lasts]
    elseif brackets[noword] then
     colourline[#colourline+1]=brackets[1]
     if not brackets._close[brackets[noword]] then brackets._close[brackets[noword]]={} end
     brackets._close[brackets[noword]][#brackets._close[brackets[noword]]+1]={#colourline,l}
     colourline[#colourline+1]=noword
    elseif brackets._close[noword] then
     if #brackets._close[noword]==0 then
      colourline[#colourline+1]=brackets[1]
     else
      if colourdetect and colourdetect[3] then
       brackets[2]= colourdetect
       colourline[#colourline-3]=colourdetect
       colourline[#colourline-7]=colourdetect
       colourline[#colourline-11]=colourdetect
      else
       brackets[2]= theme[3]
      end
      if brackets._close[noword][#brackets._close[noword]][2]==l then
       colourline[brackets._close[noword][#brackets._close[noword]][1]]=brackets[2]
       brackets._close[noword][#brackets._close[noword]]=nil
      else
       colourlines[brackets._close[noword][#brackets._close[noword]][2]][brackets._close[noword][#brackets._close[noword]][1]]=brackets[2]
       brackets._close[noword][#brackets._close[noword]]=nil
      end
      colourline[#colourline+1]=brackets[2]
     end
     colourline[#colourline+1]=noword
    elseif combo[noword] and combo[noword][lasts] and word=="" then        
     colourline[#colourline-1]=combo[noword][lasts]
     colourline[#colourline+1]=combo[noword][lasts]
     colourline[#colourline+1]=noword
    else
     colourline[#colourline+1]=highlights[noword] or theme[11]
     colourline[#colourline+1]=noword
    end
   elseif open[noword]==true then
    colourline[#colourline+1]=rest..word..noword
    rest=""
    open=0
   elseif  open[noword]==lasts and word=="" then
    colourline[#colourline+1]=open[1]
    colourline[#colourline+1]=rest..noword
    rest=""
    open=0
   else        
    rest=rest..word..noword
   end
   lasts=noword
   lastw=word
  end
  if rest~="" then
   colourline[#colourline+1]=rest
  end
  colourlines[l]=colourline
 end
 return colourlines
end

return parser
